#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <pthread.h>
#include <aitrpc.h>
#include "rc.h"


rpc_srv_t *srv;


int aaa(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
//	rpc_blob_t *b;

	RPC_CALLBACK_CHECK_INPUT(cli);

	printf("%s(%d): Piuk! aaaaaa\n", __func__, __LINE__);

	/*
	b = rpc_srv_registerBLOB(f->func_parent, BUFSIZ);
	if (!b)
		return -1;
	if (rpc_srv_blobMap(f->func_parent, b) == -1) {
		rpc_srv_blobFree(f->func_parent, b);
		return -1;
	}

	memset(b->blob_data, 0, b->blob_len);
	strcpy(b->blob_data, "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAa dsfsfsfnskjfnk\n");

	rpc_srv_blobUnmap(b);
	*/

	RPC_SET_ERRNO(rpc, EAGAIN);
	return 0;
}

int BBB(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	ait_val_t *v;
	rpc_blob_t *b;
	rpc_srv_t *s;

	RPC_CALLBACK_CHECK_INPUT(cli);
	s = RPC_SRV_SERVER(cli);

	printf("%s(%d): Piuk! %d %s %X\n", __func__, __LINE__, 
			AIT_GET_I32(array(iv, 0, ait_val_t*)), AIT_GET_STR(array(iv, 1, ait_val_t*)), 
			AIT_GET_BLOB(array(iv, 2, ait_val_t*)));

	// input blob object
	if (!(b = rpc_srv_getBLOB(s, AIT_GET_BLOB(array(iv, 2, ait_val_t*)))))
		return -1;
	if (rpc_srv_blobMap(s, b) == -1) {
		rpc_srv_blobFree(s, b);
		return -1;
	}
	printf("VAR=%X(%d):: %s\n", b->blob_var, b->blob_len, b->blob_data);
	rpc_srv_blobUnmap(b);
	rpc_srv_unregisterBLOB(s, AIT_GET_BLOB(array(iv, 2, ait_val_t*)));


	AIT_SET_BUF(ait_getVars(&RPC_RETVARS(cli), 0), "00!oo", 6);
	AIT_SET_I8(ait_getVars(&RPC_RETVARS(cli), 1), 65);
	AIT_SET_STR(ait_getVars(&RPC_RETVARS(cli), 2), "Oho boho i cheburashka");

	// return blob object
	b = rpc_srv_registerBLOB(s, 128, 0);
	if (!b)
		return -1;
	else
		AIT_SET_BLOB2(ait_getVars(&RPC_RETVARS(cli), 3), b);

	printf("data=%p blen=%d\n", b->blob_data, b->blob_len);
	memset(b->blob_data, 0, b->blob_len);
	strcpy(b->blob_data, "Hello Worldzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz mzdnfdskf\naddfs\n");

	rpc_srv_blobUnmap(b);
	return 33;
}

int xxx(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	ait_val_t *v;

	RPC_CALLBACK_CHECK_INPUT(cli);

	printf("iv_s=%d\n", array_Size(iv));
	printf("%s(%d): Piuk! --- %s\n", __func__, __LINE__, AIT_GET_BUF(array(iv, 0, ait_val_t*)));

	v = ait_getVars(&RPC_RETVARS(cli), 0);
	AIT_SET_DATA(v, "00!oo", 6);
	array_Set(RPC_RETVARS(cli), 0, v);
	AIT_SET_I8(ait_getVars(&RPC_RETVARS(cli), 1), 65);
	return 111;
}

int xYz(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	return 0;
}

int big(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	ait_val_t *v;

	RPC_CALLBACK_CHECK_INPUT(cli);

	printf("Ok lets fun... %d\n", array_Size(iv));

	mpool_dump(NULL, ">>> %s(%d) ", __func__, __LINE__);
	v = ait_getVars(&RPC_RETVARS(cli), 0);
	AIT_SET_BUFSIZ(v, '*', AIT_GET_I32(array(iv, 0, ait_val_t*)));
	mpool_dump(NULL, ">>> %s(%d) ", __func__, __LINE__);
	return 0;
}

int main(int argc, char **argv)
{
	rpc_func_t *f;
	int ret;

	if (argc > 1) {
		if (argc > 2)
			srv = rpc_srv_initServer(2, 3, 1024 * 10, "0.0.0.0", 0, SOCK_RAW);
		else
			srv = rpc_srv_initServer(2, 5, 1024 * 10, "0.0.0.0", 11111, SOCK_DGRAM);
	} else
		srv = rpc_srv_initServer(2, 2, 1024 * 10, "0.0.0.0", 11111, 0);
	if (!srv) {
		printf("error:: errno=%d %s\n", rpc_GetErrno(), rpc_GetError());
		return 1;
	}

	if (rpc_srv_initBLOBServer(srv, 0, "/tmp")) {
		printf("error:: errno=%d %s\n", rpc_GetErrno(), rpc_GetError());
		return 1;
	}

	rpc_srv_registerCall(srv, RC_aaa, aaa);
	rpc_srv_registerCall(srv, RC_BBB, BBB);
	rpc_srv_registerCall(srv, 3, NULL);
	rpc_srv_registerCall(srv, RC_xYz, xYz);
	rpc_srv_registerCall(srv, RC_xxx, xxx);
	rpc_srv_registerCall(srv, RC_big, big);

	rpc_srv_unregisterCall(srv, 4);

	rpc_register_srvServices(srv);
	rpc_register_blobServices(srv);

	mpool_dump(NULL, NULL);

	rpc_srv_execBLOBServer(srv);
	rpc_srv_loopServer(srv);

	rpc_srv_endBLOBServer(srv);
	rpc_srv_endServer(&srv);
	mpool_dump(NULL, NULL);
	return 0;
}
