#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <pthread.h>
#include <sys/wait.h>
#include <aitrpc.h>
#include "rc.h"


rpc_srv_t *srv;


int aaa(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
//	rpc_blob_t *b;

	RPC_CALLBACK_CHECK_INPUT(cli);

	printf("%s(%d): Piuk! aaaaaa\n", __func__, __LINE__);

	/*
	b = rpc_srv_registerBLOB(f->func_parent, BUFSIZ);
	if (!b)
		return -1;
	if (rpc_srv_blobMap(f->func_parent, b) == -1) {
		rpc_srv_blobFree(f->func_parent, b);
		return -1;
	}

	memset(b->blob_data, 0, b->blob_len);
	strcpy(b->blob_data, "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAa dsfsfsfnskjfnk\n");

	rpc_srv_blobUnmap(b);
	*/

	RPC_SET_ERRNO(rpc, EAGAIN);
	return 0;
}

int BBB(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	ait_val_t *v;
	rpc_blob_t *b;
	rpc_srv_t *s;

	RPC_CALLBACK_CHECK_INPUT(cli);
	s = RPC_SRV_SERVER(cli);

	printf("%s(%d): Piuk! %d %s %X\n", __func__, __LINE__, 
			AIT_GET_I32(array(iv, 0, ait_val_t*)), AIT_GET_STR(array(iv, 1, ait_val_t*)), 
			AIT_GET_BLOB(array(iv, 2, ait_val_t*)));

	// input blob object
	if (!(b = rpc_srv_getBLOB(s, AIT_GET_BLOB(array(iv, 2, ait_val_t*)))))
		return -1;
	if (rpc_srv_blobMap(s, b) == -1) {
		rpc_srv_blobFree(s, b);
		return -1;
	}
	printf("VAR=%X(%d):: %s\n", b->blob_var, b->blob_len, b->blob_data);
	rpc_srv_blobUnmap(b);
	rpc_srv_unregisterBLOB(s, AIT_GET_BLOB(array(iv, 2, ait_val_t*)));


	AIT_SET_BUF(ait_getVars(&RPC_RETVARS(cli), 0), "00!oo", 6);
	AIT_SET_I8(ait_getVars(&RPC_RETVARS(cli), 1), 65);
	AIT_SET_STR(ait_getVars(&RPC_RETVARS(cli), 2), "Oho boho i cheburashka");

	// return blob object
	b = rpc_srv_registerBLOB(s, 128, 0);
	if (!b)
		return -1;
	else
		AIT_SET_BLOB2(ait_getVars(&RPC_RETVARS(cli), 3), b);

	printf("data=%p blen=%d\n", b->blob_data, b->blob_len);
	memset(b->blob_data, 0, b->blob_len);
	strcpy(b->blob_data, "Hello Worldzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz mzdnfdskf\naddfs\n");

	rpc_srv_blobUnmap(b);
	return 33;
}

int xxx(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	ait_val_t *v;

	RPC_CALLBACK_CHECK_INPUT(cli);

	printf("iv_s=%d\n", array_Size(iv));
	printf("%s(%d): Piuk! --- %s\n", __func__, __LINE__, AIT_GET_BUF(array(iv, 0, ait_val_t*)));

	v = ait_getVars(&RPC_RETVARS(cli), 0);
	AIT_SET_DATA(v, "00!oo", 6);
	array_Set(RPC_RETVARS(cli), 0, v);
	AIT_SET_I8(ait_getVars(&RPC_RETVARS(cli), 1), 65);
	return 111;
}

int xYz(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	return 0;
}

int big(rpc_cli_t *cli, struct tagRPCCall *rpc, array_t *iv)
{
	RPC_CALLBACK_CHECK_INPUT(cli);
	ait_val_t *v;

	printf("Ok lets fun... %d\n", array_Size(iv));

	v = ait_getVars(&RPC_RETVARS(cli), 0);
	AIT_SET_BUFSIZ(v, '*', 5000000);
	return 0;
}

int main(int argc, char **argv)
{
	rpc_func_t *f;
	int ret, fds[2];

	if (argc < 2) {
		printf("not enough parameters ... where is tcliext program?\n");
		return 1;
	}

	if (socketpair(AF_LOCAL, SOCK_STREAM, 0, fds) == -1) {
		printf("error:: errno=%d %s\n", errno, strerror(errno));
		return 1;
	}

	switch (fork()) {
		case -1:
			printf("error:: errno=%d %s\n", errno, strerror(errno));
			return 1;
		case 0:
			close(fds[1]);
			dup2(fds[0], 2);
			close(fds[0]);
			sleep(1);
			execl(argv[1], argv[1], NULL);
			return 127;
		default:
			close(fds[0]);
	}

	srv = rpc_srv_initServerExt(2, 1024 * 10, fds[1]);
	if (!srv) {
		printf("error:: errno=%d %s\n", rpc_GetErrno(), rpc_GetError());
		return 1;
	}

	rpc_srv_registerCall(srv, RC_aaa, aaa);
	rpc_srv_registerCall(srv, RC_BBB, BBB);
	rpc_srv_registerCall(srv, 3, NULL);
	rpc_srv_registerCall(srv, RC_xYz, xYz);
	rpc_srv_registerCall(srv, RC_xxx, xxx);
	rpc_srv_registerCall(srv, RC_big, big);

	rpc_srv_unregisterCall(srv, 4);

	rpc_register_srvServices(srv);

	rpc_srv_loopServer(srv);
	rpc_srv_endServer(&srv);
	close(fds[1]);
	wait(&ret);
	return 0;
}
