/*************************************************************************
* (C) 2010 AITNET ltd - Sofia/Bulgaria - <misho@aitbg.com>
*  by Michael Pounov <misho@openbsd-bg.org>
*
* $Author: misho $
* $Id: defs.h,v 1.19 2015/07/02 22:28:14 misho Exp $
*
**************************************************************************
The ELWIX and AITNET software is distributed under the following
terms:

All of the documentation and software included in the ELWIX and AITNET
Releases is copyrighted by ELWIX - Sofia/Bulgaria <info@elwix.org>

Copyright 2004 - 2015
	by Michael Pounov <misho@elwix.org>.  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
This product includes software developed by Michael Pounov <misho@elwix.org>
ELWIX - Embedded LightWeight unIX and its contributors.
4. Neither the name of AITNET nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY AITNET AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
#ifndef __DEFS_H
#define __DEFS_H


#ifndef DEF_RPC_TIMEOUT
#define DEF_RPC_TIMEOUT		10
#endif

#ifndef DEF_RPC_BLOB_TIMEOUT
#define DEF_RPC_BLOB_TIMEOUT	60
#endif

#define RPC_SCHED_POLLING	1

#ifndef STRSIZ
#define STRSIZ			256
#endif

#define RPC_MIN_BUFSIZ		512
#define SOCK_MAX_SUPPORT	6

#define CB_ACCEPTCLIENT		0
#define CB_CLOSECLIENT		1
#define CB_RXPACKET		2
#define CB_TXPACKET		3

#define BLOB_FILE		"%s/BLOB-%0X"


#define LOGERR	do { \
			rpc_Errno = errno; \
			strlcpy(rpc_Error, strerror(errno), sizeof rpc_Error); \
		} while(0)


extern int rpc_Errno;
extern char rpc_Error[STRSIZ];

void rpc_freeCli(rpc_cli_t * __restrict);
void rpc_freeBLOBCli(rpc_cli_t * __restrict);

#if 0
#if ONLY_CLI == 0
int rpc_funcs_cmp(struct tagRPCFunc *, struct tagRPCFunc *);
AVL_PROTOTYPE(tagRPCFuncs, tagRPCFunc, func_node, rpc_funcs_cmp);
#endif
#endif


#endif
